osgGA::GUIEventHandler Class Reference

`#include <GUIEventHandler>`

Inheritance diagram for osgGA::GUIEventHandler:

## Public Member Functions

| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
virtual bool | handle (const GUIEventAdapter &, GUIActionAdapter &)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
virtual void | getUsage (osg::ApplicationUsage &) const
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Protected Member Functions

virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

GUIEventHandler provides a basic interface for any class which wants to handle a GUI Events.

The GUIEvent is supplied by a GUIEventAdapter. Feedback resulting from the handle method is supplied by a GUIActionAdapter, which allows the GUIEventHandler to ask the GUI to take some action in response to an incoming event.

For example, consider a Trackball Viewer class which takes mouse events and manipulates a scene camera in response. The Trackball Viewer is a GUIEventHandler, and receives the events via the handle method. If the user 'throws' the model, the Trackball Viewer class can detect this via the incoming events, and request that the GUI set up a timer callback to continually redraw the view. This request is made via the GUIActionAdapter class.

## Constructor & Destructor Documentation

## GUIEventHandler() [1/2]

osgGA::GUIEventHandler::GUIEventHandler | ( |  | ) |

inline

Referenced by GUIEventHandler(), osgViewer::InteractiveImageHandler::InteractiveImageHandler(), and META_Object().

## GUIEventHandler() [2/2]

osgGA::GUIEventHandler::GUIEventHandler | ( | const GUIEventHandler & | eh,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References osg::Callback::Callback(), osgGA::EventHandler::EventHandler(), GUIEventHandler(), osg::Object::Object(), and osg::CopyOp::SHALLOW_COPY.

## ~GUIEventHandler()

virtual osgGA::GUIEventHandler::~GUIEventHandler | ( |  | ) |

protected virtual

## Member Function Documentation

## handle() [1/3]

virtual bool osgGA::GUIEventHandler::handle | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

inline virtual

Deprecated, Handle events, return true if handled, false otherwise.

Reimplemented in osgAnimation::StatsHandler, osgGA::AnimationPathManipulator, osgGA::CameraManipulator, osgGA::CameraViewSwitchManipulator, osgGA::DriveManipulator, osgGA::KeySwitchMatrixManipulator, osgGA::MultiTouchTrackballManipulator, osgGA::SphericalManipulator, osgGA::StandardManipulator, osgGA::StateSetManipulator, osgGA::UFOManipulator, osgPresentation::PropertyEventCallback, osgPresentation::SlideEventHandler, osgViewer::HelpHandler, osgViewer::LODScaleHandler, osgViewer::RecordCameraPathHandler, osgViewer::ScreenCaptureHandler, osgViewer::StatsHandler, osgViewer::ThreadingHandler, osgViewer::ToggleSyncToVBlankHandler, and osgViewer::WindowSizeHandler.

## handle() [2/3]

virtual bool osgGA::GUIEventHandler::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | aa,
|  | osg::Object * | ,
|  | osg::NodeVisitor * | )

inline virtual

Handle events, return true if handled, false otherwise.

Reimplemented in osgPresentation::KeyEventHandler, osgPresentation::PickEventHandler, osgViewer::InteractiveImageHandler, osgViewer::KeystoneHandler, osgVolume::PropertyAdjustmentCallback, osgWidget::CameraSwitchHandler, osgWidget::KeyboardHandler, osgWidget::MouseHandler, and osgWidget::ResizeHandler.

References handle().

Referenced by handle().

## handle() [3/3]

virtual bool osgGA::GUIEventHandler::handle | ( | osgGA::Event * | event,
|  | osg::Object * | object,
|  | osg::NodeVisitor * | nv )

virtual

Handle event. Override the handle(..) method in your event handlers to respond to events.

Reimplemented from osgGA::EventHandler.

Reimplemented in osgGA::CameraManipulator.

References osgGA::EventHandler::event().

Referenced by osgGA::CameraManipulator::handle().

## META_Object()

osgGA::GUIEventHandler::META_Object | ( | osgGA | ,
|  | GUIEventHandler | )

References GUIEventHandler().

The documentation for this class was generated from the following file:

- GUIEventHandler